import java.io.*;
import java.util.*;
import net.sourceforge.jFuzzyLogic.FIS;

public class evaluaEvento 
{

	public static double evalua(String[] lflog,int l) 
	{
		
		int lin=0;
		int pos=0;
		int ini=0;
		int fin=0;
		double red=0;
		double green=0;
		int muertos=0;
		double poblacion=0;
		double influencia=0;
		double est=0;
		double dis=0;
		int x=0;
		int z=0;
		

		//Elimina los muertos
		while(lin<l) 
		{
			
			if (lflog[lin].startsWith("   muere"))
			{
				fin=lflog[lin].indexOf(" ",4);
				pos=Integer.parseInt(lflog[lin].substring(8, fin));
				lflog[pos]=" muerto";
				muertos++;
			}
			else 
			{
				if (lflog[lin].startsWith("   nace"))
				{
					fin=lflog[lin].indexOf(" ",4);
					pos=Integer.parseInt(lflog[lin].substring(7, fin));
					lflog[pos]=lflog[lin];
				}
			}
			lin++;
		}

		
       		// Load from 'FCL' file
       		String fileName = "evalua.fcl";

		FIS fis = FIS.load(fileName,true);
        	// Error while loading?
        	if( fis == null ) 
		{ 
            		System.err.println("Can't load file: '" + fileName + "'");
            		return poblacion;
        	}
			
		//Evaluamos con las variables de entrada est y dis
    

        	// Show 
		fis.chart();

		lin=0;
		while(lin<l-muertos) 
		{
			if(lflog[lin].startsWith("   nace"))
			{
				ini=lflog[lin].indexOf("x",1);
				fin=lflog[lin].indexOf("z",1);
				x=Integer.parseInt(lflog[lin].substring(ini+2, fin-1));

				ini=lflog[lin].indexOf("z",1);
				fin=lflog[lin].indexOf("r",1);
				z=Integer.parseInt(lflog[lin].substring(ini+2, fin-2));
			
				dis=Math.sqrt((x*x)+(z*z));

				ini=lflog[lin].indexOf("r",1);
				fin=lflog[lin].indexOf("g",1);
				red=Double.valueOf(lflog[lin].substring(ini+2, fin-2)).doubleValue();

				ini=lflog[lin].indexOf("g",1);
				fin=lflog[lin].indexOf("b",1);
				green=Double.parseDouble(lflog[lin].substring(ini+2, fin-2));
			
				est=1+green-red;

		        	// Set inputs
			     	fis.setVariable("estado", est);
				fis.setVariable("distancia", dis);

		        	// Evaluate
				fis.evaluate();

		        	// Show output variable's chart 
			     	fis.getVariable("influencia").chartDefuzzifier(true);

				// Show output variable's string
				influencia=fis.getVariable("influencia").getLatestDefuzzifiedValue();
		
				System.out.println("Estado: "+est+" Distancia: "+dis+" Influencia "+lin+" : "+influencia);
				poblacion=poblacion+influencia;
			}

			lin++;
		}

		return poblacion;
	} 
}
