package net.sourceforge.jFuzzyLogic;

/**
 * Show variables from a FIS
 * @author pcingola@users.sourceforge.net
 */
public class ShowVariables {

	public static void main(String[] args) throws Exception {
		// Check args
		if( args.length <= 0 ) {
			System.err.println("Usage: ShowVariables file.fcl");
			System.exit(1);
		}

		// Read file
		String fileName = args[0];
		String fcl = Gpr.readFile(fileName);

		// Create FIS
		FIS fis = FIS.createFromString(fcl, true);

		// Show variables for each function block
		for( FunctionBlock functionBlock : fis )
			functionBlock.chart();
	}
}
