package net.sourceforge.jFuzzyLogic.defuzzifier;

import net.sourceforge.jFuzzyLogic.rule.Variable;

/**
 * Center of gravity defuzzyfier
 * @author pcingola@users.sourceforge.net
 */
public class DefuzzifierCenterOfGravity extends DefuzzifierContinuous {

	public DefuzzifierCenterOfGravity(Variable variable) {
		super(variable);
	}

	/** Deffuzification function */
	public double defuzzify() {
		double x = min, sum = 0, weightedSum = 0;

		// Calculate integrals (approximated as sums)
		for( int i = 0; i < values.length; i++, x += stepSize ) {
			sum += values[i];
			weightedSum += x * values[i];
		}

		// No sum? => this variable has no active antecedent
		if( sum <= 0 ) return Double.NaN;

		// Calculate center of gravity
		double cog = weightedSum / sum;
		return cog;
	}

	public String toStringFcl() {
		return "METHOD : COG;";
	}
}
